"""

要求：有一个sort方法，方法接收两个参数，一个参数是列表，另外一个参数是排序方法
例如：当传入bubble时，则调用冒泡排序的方法进行排序，并打印出每一步数字挪动的过程
    当传入quick时，则调用快速排序的方法进行排序，并打印出每一步数字挪动的过程
外部不可以直接访问具体排序方法，只能调用sort方法

"""


class SortUtils:

    def __init__(self, array, algorithm):
        self.array = array
        self.algorithm = algorithm

    def sort(self):
        if self.algorithm == 'bubble':
            self.__bubble()
        elif self.algorithm == 'quick':
            self.__quick()
        else:
            raise RuntimeError("not support this algorithm")
        return self.array

    def __bubble(self):
        for i in range(len(self.array) - 1):
            for j in range(len(self.array) - 1 - i):
                if self.array[j] > self.array[j + 1]:
                    self.array[j], self.array[j + 1] = self.array[j + 1], self.array[j]

    def __quick(self):
        left, right = 0, len(self.array) - 1
        stack = []
        stack.append(left)
        stack.append(right)
        while stack:
            low = stack.pop(0)
            high = stack.pop(0)
            if high - low <= 0:
                continue
            x = self.array[high]
            i = low - 1
            for j in range(low, high):
                if self.array[j] <= x:
                    i = i + 1
                    self.array[i], self.array[j] = self.array[j], self.array[i]
            self.array[i + 1], self.array[high] = self.array[high], self.array[i + 1]
            stack.extend([low, i, i + 2, high])


array = [1, 7, 8, 9, 30, 5, 6]

# self
sort1 = SortUtils(array, "bubble")
sort2 = SortUtils(array, "quick")
print(sort1 == sort2)
print(SortUtils(array, 'bubble').sort())
print(SortUtils(array, 'quick').sort())
